#-----------------------------------------------------------------------------
'''
Proportioner
5/17/2015
by Ockham
occam24@aol.com

Designed to help with ratios.  Ordinary calculators require
a considerable amount of thinking to form a ratio, and it's
not easy to 'transpose' the ratio.  This should help.


'''

#-----------------------------------------------------------------------------

from Tkinter import *
import math

global Num1,Den1,Num2,Den2
Num1,Den1,Num2,Den2 = (1.0,1.0,1.0,1.0)

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("proportioner")

        self.TopTitle = Label(self.master,width=50,text=" Inputs              Ratio               Outputs ")
        self.TopTitle.grid(row=0,column=0,columnspan=3,pady=6)

        self.Num1Entry = Entry(self.master,width=10)
        self.Num1Entry.grid(row=1,column=0,pady=6)
        self.Slash1 = Label(self.master,text="---------------")
        self.Slash1.grid(row=2,column=0,pady=6)
        self.Den1Entry = Entry(self.master,width=10)
        self.Den1Entry.grid(row=3,column=0,pady=6)

        self.RatioEntry=Entry(self.master,width=10)
        self.RatioEntry.grid(row=2,column=1)

        self.Num2Entry = Entry(self.master,width=10)
        self.Num2Entry.grid(row=1,column=2,pady=6)
        self.Slash2 = Label(self.master,text="---------------")
        self.Slash2.grid(row=2,column=2,pady=6)
        self.Den2Entry = Entry(self.master,width=10)
        self.Den2Entry.grid(row=3,column=2,pady=6)

        self.Num1Entry.focus()

        self.Num1Entry.bind("<Return>",self.FromNum1)
        self.Num1Entry.bind("<Enter>",self.ClearNum1)

        self.Den1Entry.bind("<Return>",self.FromDen1)
        self.Den1Entry.bind("<Enter>",self.ClearDen1)

        self.Num2Entry.bind("<Return>",self.FromNum2)
        self.Num2Entry.bind("<Enter>",self.ClearNum2)

        self.Den2Entry.bind("<Return>",self.FromDen2)
        self.Den2Entry.bind("<Enter>",self.ClearDen2)

        self.Num1Entry.focus()


        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -

    # So clicking into each blank clears it

    def ClearNum1(self,event):
        self.Num1Entry.delete(0,END)
        self.Num1Entry.focus()
    def ClearNum2(self,event):
        self.Num2Entry.delete(0,END)
        self.Num2Entry.focus()
    def ClearDen1(self,event):
        self.Den1Entry.delete(0,END)
        self.Den1Entry.focus()
    def ClearDen2(self,event):
        self.Den2Entry.delete(0,END)
        self.Den2Entry.focus()

    # - - - - - - - - - - - - - - - - - -

    def FromNum1(self,event):
        global Num1,Den1,Ratio,Num2,Den2

        Num1=float(self.Num1Entry.get())
        if Den1==0.0: Den1=1.0
        if Den2==0.0: Den2=1.0
        Ratio=Num1/Den1

        if Den2==1.0: Num2=Ratio

        self.RatioEntry.delete(0,END)
        RatioString="%.3f" % Ratio
        self.RatioEntry.insert(0,RatioString)
        self.Num2Entry.delete(0,END)
        Num2String="%.3f" % Num2
        self.Num2Entry.insert(0,Num2String)

        self.Den1Entry.focus()

    # - - - - - - - - - - - - - - - - - -

    def FromDen1(self,event):
        global Num1,Den1,Ratio,Num2,Den2

        Den1=float(self.Den1Entry.get())

        if Den1==0.0: Den1=1.0
        if Den2==0.0: Den2=1.0
        Ratio=Num1/Den1

        if Den2==1.0: Num2=Ratio
        else: Num2=Ratio*Den2

        self.RatioEntry.delete(0,END)
        RatioString="%.3f" % Ratio
        self.RatioEntry.insert(0,RatioString)
        self.Num2Entry.delete(0,END)
        Num2String="%.3f" % Num2
        self.Num2Entry.insert(0,Num2String)

        self.Num2Entry.focus()

    # - - - - - - - - - - - - - - - - - -

    def FromNum2(self,event):
        global Num1,Den1,Ratio,Num2,Den2
        Num2=float(self.Num2Entry.get())
        if Den1==0.0: Den1=1.0
        if Den2==0.0: Den2=1.0
        # don't figure the ratio from this side. Just alter the other member on this side.

        Den2=Num2/Ratio
        self.Den2Entry.delete(0,END)
        Den2String="%.3f" % Den2
        self.Den2Entry.insert(0,Den2String)

        self.Den2Entry.focus()

    # - - - - - - - - - - - - - - - - - -

    def FromDen2(self,event):
        global Num1,Den1,Ratio,Num2,Den2
        Den2=float(self.Den2Entry.get())
        if Den1==0.0: Den1=1.0
        if Den2==0.0: Den2=1.0

        # don't figure the ratio from this side. Just alter the other member on this side.

        Num2=Den2 * Ratio

        self.Num2Entry.delete(0,END)
        Num2String="%.3f" % Num2
        self.Num2Entry.insert(0,Num2String)

        self.Num1Entry.focus()

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
